Introduction

This document assumes that you have an English install of Notepad++. If you have installed it in another language, the commands and options will probably have been translated into your native language. In that case, find the command with the similar name, the logical grouping will still be the same. p>All the images used in this helpfile assume the default settings. If you change any of these settings, you'll have to look for the other image instead, this is most noticable with the toolbar (the position of images will always remain the same).

Also, when talking about the left and right mouse buttons, the logical left and right is meant. These are the same as the physical left and right mouse buttons in the case of a right-handed setup. However, if you have a left-handed setup you will probably have the buttons swapped so act accordingly. This means in general you do what you normally do for most actions, Notepad++ mostly follows the standard Windows application behavior.

Likewise, the layout is discussed as it is displayed in a left-to-right order. On right-to-left systems (such as Hebrew) translated versions of Notepad++ can have the display order reversed, adjust accordingly as well.

This helpfile uses some markup to distinguish certain interface elements or interaction.

When an option from the menu can be selected (open the menu then select the option), it will look like this: | Menu->Option where an arrow means 'Option' is in a submenu of 'Menu'
When a button in the GUI can be pressed, it will be marked like this: | Button
Checkboxes can be toggled in on or off mode and are marked like this: | Checkbox
Radiobuttons are like checkboxes, but in a single group of radiobuttons only one can be selected. Radiobuttons are marked like this: | Radiobutton
Sometimes labels are used in the GUI to describe an element when they cannot have any text associated with them directly. Labels look like this: | Label
Finally, when mouse or keyboard interaction is required, the buttons or keys to press are marked like this: | Leftmousebutton

This markup is based in the default appearance of Microsoft Windows. This can be different on your own system, but the names (text) should always the same. This is especially important on the screenshots. They are only for reference, your appearance of Notepad++ can be quite different.

This helpfile is dedicated to the countless lost hours of both people having to search for simple answers, and people having to answer questions that shouldn't have to be asked in the first place. Documentation is always hard to get, good documentation nearly impossible =].

This help file was written by Harry (harrybharry@users.sourceforge.net) and converted to HTML using KompoZer, compiled to a help file with Microsoft HTML Help Workshop. Notepad++ is a product by Don Ho, Microsoft and Microsoft Windows are registered trademarks.


File management

How to manage your files:

Creating new files

Opening and Saving files

Closing files

Activating a file

Editing files

Read-only files

Note: See the section about the Windows dialog to see other methods to manage your files.


File Creation

Creating new files:

To create a new file, go to File->New or press [image]. A new empty tab will appear with the title “New 1”, where the number depends on how many new files you have created.


Opening and Saving

Opening and Saving files:

Opening goes very similar to any other windows application.

  • To open a file, simply go to File->Open or press [image]. A dialog will appear and you can select one or more files that have to be opened. Each file will be opened in an individual tab. If the file was already opened, Notepad++ will show you that file in its current state. In the dialog, at the bottom there is a filter that will allow you to only show the files that belong to a certain language (such as C++ or PHP) depending on the extension. By default all files are shown.
  • Another way to open a file is to drag the file into Notepad++ using the cursor. This can also be done with multiple files selected or whole folders.
  • Additionally, Notepad++ keeps a list of unopened, recently closed files in the File menu so you can reopen them quickly. Simply click on the filename to open it (see the section about Settings, Recent file list for more details). To open all the files in that list, simply select File->Open All Recent Files (selecting File->Clean Recent Files List will clear that list).
  • See also the section about the Command Line to see how to open files using the command line.

Saving a file can be done in multiple ways.

  • The default way is to select File->Save or press [image]. If it is an existing file it will be overwritten with the current contents. Note that if the file has not been modified, you cannot save the file.
  • If you want to save all the files you have opened at once, you can select File->Save All or press [image].
  • If the file has yet no name (for example, if you had created a new file), or you selected File->Save As, the save file dialog will pop up, asking you for the name of the file. You can then choose the location and the name of the file.
  • An useful variant is File->Save a Copy As. The difference with File->Save As is that, after the latter, your work continues on the new file, while with the former it continues on the old file.
  • The filter at the bottom of the dialog can automatically add or change the extension for you. Depending in the first extension listed for that language, the filename will be changed to have that extension.

You can Reload a file if you wish to update the current view of the file (for example, if the file has been modified) or restore its contents to what is on disk if you have modified the file but not yet saved. If the file has been changed on disk, by default Notepad++ will ask you if you wish to reload it (see Preferences for more details).

You can do so by selecting File->Reload from Disk.

Finally, you can choose to Rename a file by selecting File->Rename. A dialog will pop up asking you for the new name of the file, similar to the Save As dialog. However, the original file will be deleted.


Closing

Closing files

In order to close the files you have open, you have multiple options at hand. Remember that if you have any unsaved data in a file, Notepad++ will always ask you if you'd like to save those changes before closing any file.

Primarily, you can close any file by selecting File->Close or press [image].

To close all files, select File->Close All or press [image].

To close all the files but the active one, select File->Close All but Active.

You can also close any tab by clicking on it with the middle mouse button. This way you can close tabs without having to bring them to the foreground. A right click on the tab will invoke a context menu, from which the topmost entry is Close me. That works just as well if you have only two mouse buttons.

There is also a setting that allows you to close any tab by doubleclicking on it, or show a close button on each tab ( [image]). To see how to do this, see the section about configuring the Tab Bar in the Preference dialog

Finally, you can close any active tab by clicking on the cross in the top-right corner of the menu bar.


Activating

Activating a file:

Notepad++ allows you to open multiple files at once, or multiple files multiple times, but only one will be active (have focus) at any time. All files are represented on the tab bar with their filename and an icon indicating if its normal, edited or readonly (see the section about the Tab Bar for more details). Simply click on a tab to activate the file. You can also use the Ctrl-TAB and Ctrl-Shift-TAB key combinations to switch through the active files, or depress the right mouse button and use the scroll wheel (see also Switching between Documents).

If you have Multi-View enabled, only one view can be actually active, however you can see both files (see also the section about Multi-View).


Editing

Editing files:

When you edit a file, Notepad++ will mark the file as edited, allowing you to save it if you wish to store these changes. To indicate a file is edited, the icon in the tabbar will turn red ( [image]) and an asterisk (*) will be displayed in the titlebar before the filename if that file is active.


Read-Only

Read-only files:

Documents in Notepad++ can be marked as read-only, meaning they cannot be modified.

Notepad++ recognizes two read-only states:

  • The file in the filesystem is marked as read-only. You can only enable the editing of the file by clearing the read-only flag. You can do so by selecting Edit->Clear Read Only Flag.
  • The document in Notepad++ is marked as read-only. You can manually set this option by selecting Edit->Set Read Only. The document in Notepad++ cannot be edited, but if the file exists in the filesystem it will not be marked as read-only, this is just an internal state.


Session management

Sessions are a set of files opened in Notepad++. They store the open files, the active file (and which view, see the section about Multi-View), the current selection and position in the file, the current bookmarks (see Bookmarks) and the current language (see the section about Languages). Using sessions, you can open a set of (related) files with one action.

Loading sessions

Saving sessions


Loading sessions

To load a session, simply go to File->Load Session. Then select any session you like and it will open the files contained in it, and restore their state.

If you have set a default session extension (for example, .session) for Notepad++, you can also open a session using the regular means to open a file. If the file has the extension for a session, Notepad++ will attempt to load it (see also the section for Preferences

Depending if you have set a default extension for session files, you can filter for those files in the Load Session dialog.


Saving sessions

To save a session, select File->Save Session and select the location and name of the session to be saved. This is very similar to saving files, but instead for sessions.

When the option to remember the last session is set in the Preferences dialog, Notepad++ automatically saves the current session on shutdown, except if it was launched with the -nosession command line option.


Editing

Primarily editing files is done by simply using the keyboard (or the standard Input Method Editor (IME) for eastern asian language) to change the contents, inserting and deleting text as needed. However, Notepad++ has many tools and aids to assist in editing files, mainly to automate repetitive tasks or speed up development.

Notepad++ is based on the Scintilla edit control and relies on it to perform many editing tasks, supplementing it if useful.

Standard Operations

Indentation

Selecting text

Overtype

Auto Completion

Column Mode Editing

Commenting

Other editing tools


Standard operations

The edit control supports simple Undo, Redo and Cut, Copy and Paste. These standard operations can be found in most editors and perform in very similar ways. You can perform these operations by selecting the corresponding menu item in the Edit menu, or clicking its button on the toolbar ( [image] for cutting text, [image] for copying, [image] for pasting, [image] for undo and [image] for redo). Additionally, by default the Cut, Copy and Paste options are available in the context menu (see the section Context Menu for more information).

Browsing the Shortcut mapper will show you more editing commands that duplicate or move lines, or send a line to clipboard without selecting it. See also Other editing tools.


Indentation

Indenting text is a common operation when dealing with source code editing, and Scintilla and Notepad++ have full support for it. Indentation is the addition of extra whitespace at the start of a line to separate blocks of text, adding a hierarchy.

Normally when editing, pressing the Tab key will insert a tab character at the current location. However, if some text is selected, pressing the Tab key (by default) will add additional whitespace at the beginning of each line that has any selected text, allowing to indent entire blocks of text at once. Pressing Shift-TAB will remove the indentation.

Indentation is done in levels, each level adding a predefined amount of whitespace (this amount can be configured on a per language basis, see Preferences). There is also an option of choosing whether to insert a TAB character or (multiple) spaces (for this, also see Preferences).

Scintilla can show a line/guide for each level, which can be toggled by selecting View->Show Symbol->Show Indent Guide or pressing [image]. This guideline shows a visual cue to keep track of the current indentation level of lines. To change the color used, see Styler Configurator (note that if the guideline matches highlighted braces, it will assume the color of the brace highlight).


Overtype

You can enable and disable overtyping (that is, instead of inserting characters at the cursor, you replace them) by pressing insert, or clicking on the rightmost section of the statusbar, which will indicate the current mode: INS for inserting characters, OVR for overwriting them (overtype). The displayed cursor will also change shape accordingly (see also Preferences for the cursor).


Selecting text

As with any known text editor, you can select text using either the mouse or keyboard. Selected text can be moved to some other part of the same document, copied elsewhere in the same or another document, searched for text, deleted, an more.

How to select text

When using the mouse, the most basic way - but there are other - is to drag the mouse from start point to end point. You can also double click a word to select it, or triple click on a line to select it. The same effect is achieved by a simple click on the line number margin, when displayed. You can extend a selection by shift clicking its new insertion point.

When using the keyboard, the expected procedure is to use navigation keys in conjunction with the Shift modifier. These keyboard shortcuts can be changed at any time using the Shortcut Mapper.

Stream vs rectangular selection

The above procedures are known to define a stream selection, which encompasses a contiguous range of text.

However, Notepad++ also knows about rectangular selections, which define a rectangle of strips on contiguous lines. To select a rectangle, use the above methods while also holding the Alt modifier key down. For exmple, the basic way with the mouse is to Alt-click the start point and Alt-move the mouse to the end point, and so forth. The Alt- versions of keyboard shortcuts can be changed as well.

It is possible to combine a stream selection and arectangular selection, using the keyboard. This is probably less useful, but is not a bug.

The Edit -> Line operations -> Move Up/Down current line commands also move the selected area, if it is not rectangular. This ability is lost when several selections are made - see below.

Multiple stream selections

If a stream area is selected, it is possible to add another, disjoint area by Ctrl-clicking its start point and moving the mouse to the end point. More than one extra selection can be added this way. However, this ability does not extend to rectangular selections. A rectangular selection may still cling to one of the stream selections though.

When copying or cutting a multiple selection, the text is recorded in the order the selections appear, regardless of the order in which they were made.


Auto completion

Notepad++ has autocompletion capabilities, allowing it to finish a word that you are typing by giving a list of possible options, or immediately inserting it when only one possibility is left (powered by the Scintilla component).

There are two types of auto completion.

  • The first one uses a list of well known keywords and provides a hint based on that and goes by the name Function Completion. It is triggered by selecting Edit->Auto-Completion->Function Completion or automatically when a certain amount of characters is typed (see also Preferences).
  • The second one retrieves all the words from the current file and provides hinting on that, named Word Completion. This is triggered by selecting Edit->Auto-Completion->>Word Completion, or by entering a set number of characters (again, see Preferences). Word completion is the only type that can automatically finish a word without displaying a list of options first.
Somewhat related but not exactly the same is the display of function parameter hints, or calltips. This is a small tooltip that will show the required parameters (and possibly some details of them) for a function a call to which is being edited. This is specifically targeted for programming purposes and serves no real value for other tasks. The calltip will highlight the current parameter being edited for a quick emphasis on what is actually needed. It is purely passive and will not modify the text in any way. To trigger a calltip (if one can be found), select Edit->Auto-Completion->Function parameters hint.

Autocompletion is language based (see Languages) and has different API files for each language. For more details on these API files and how to make your own, refer to NpWiki++.


Column Mode editing

A special way of editing files is column mode editing. This means that text can be selected in columns, rather than rows (effectively meaning 'vertical editing'). The column editing support is done via Scintilla, but with a few supplements of Notepad++. To initiate a Column mode selection, depress the Alt key (default) when selecting text (using mouse or cursor keys), moving the cursor downwards or upwards as needed. This works best if a non-proportional (monospaced) font is used, because then each character will be aligned with the ones above and below it (refer to Styler Configurator for more information).

When text is selected in this so called rectangilar mode, typing will change each selected column of characters into the typed character, or insert such a column. Use the ESC key to exit this special typing mode. To back up one column, use the Edit->Undo feature, instead of the Backspace key.

The Column Editor dialog is designed to make working with columns easier. It can be opened by selecting Edit->Column Editor.

There are two types of insertions that the column editor supports, regular text or number sequences.

  • By selecting the Text to insert option, it will overwrite each selected row with the given text.
  • The Number to insert option will change each selected row into a numeric value, depending on the parameters given:
    • The Initial number is the first number to be inserted.
    • The Increase by value gives the value by which each consecutive number will increase.
    • If the Leading zeros option is checked, smaller values will be padded with zeros to make them the same size as larger values, character wise.
    • Finally, you can choose which radix to use for numbers (Format), default is Decimal (10 base).


Commenting

When programming, it is often useful to comment (adding certain tags around or in front of text to mark it is non-code) or uncomment (large) section of text. Notepad++ allows to add two types of comments:

  • block comments, which means adding a special tag in front of each line of (selected) text.
  • stream comments, which means putting special tags around the selected text.

Notepad++ can also remove block comments from text, or toggle them (adding them where absent and removing them where present). These options are available from the Edit menu or the Context Menu (see the section about the Context Menu for more details).

  • To add block comment tags, select Edit->Comment/Uncomment->Block comment.
  • To remove block comment tags, select Edit->Comment/Uncomment->Block uncomment.
  • To Toggle tags for all selected lines, select Edit->Comment/Uncomment->Block toggle comment
  • To add stream comment tags around the selected text, select Edit->Comment/Uncomment->Stream comment.
p>Note that if a block comment starts in column 1, and you toggle block comment on a range of lines that contains the line, the line will be uncommented, which is not usually desired. This behaviour is difficult to avoid.


Other editing tools

Look in the Edit menu for more editing capabilities, or in the Shortcut Mapper under the Scintilla section (see Shortcut Mapper for more details). It is mostly for working on a per line basis. The Edit -> Trim Trailing Space command will remove any trailing whitespace from selected lines.


Printing

Notepad++ allows you to print a file with its current syntax coloring (see also the section about Languages). If you select File->Print, the Print dialog will be shown allowing you to setup your printer before printing. Selecting File->Print Now! or clicking on [image] will immediately print the current file. To setup how a file should be printed, see Preferences


Exiting

Exiting Notepad++

To exit Notepad++, select File->Exit or press the close button in the titlebar. If you have any unsaved changes, Notepad++ will ask you if you want to save these changes (or cancel the exit process). When exiting, Notepad++ will save the current session by default (see the section Session management) so it will reopen it on the next restart. To change this behavior, see the section Preferences.

Sometimes, for various reasons (a rogue plugin, or some bug of the operating system), Notepad++ shuts down anomalously in a spontaneous way - it is said to crash. In such a situation, it does two things:

  1. It attempts to save any unsaved data, if any. The results are in %TEMP%\N++RECOV\. Notepad++ will pop message boxes up to inform you of the process.
  2. On closing, it will produce a ~300k binary file called NppDump.dmp. Sending the file to a Notepad++ developer will help them understand the crash and fix the application as soon as possible, so that such events occur on an exceptional basis only. If the culprit is a plugin, the plugin author may be notified with insights into the crash, for them to take action.


Document Properties

A document has certain characteristics in the way its stored on your hard-disk. These subjects control some of those aspects.

Newline format

Encoding

Note: both the default Newline format and the encoding of new files can be set, see New document settings for more details.


Newline format

Files that have multiple lines of text have special newline characters to indicate where one line ends and a new one begins. Because operating systems have had different traditional formats, Notepad++ and Scintilla have support to handle and them. When editing a file, Notepad++ will try to determine the newline format used and base any newline operations on that. To change the format used, simple select it from the Format menu. All newlines will be changed and subsequent newlines added will be of this format.


Encoding

Text can be encoded in multiple ways. Most (older) textfiles use an encoding named ANSI, which has room for a limited amount of different characters, but is often sufficient to display all the text. However, Unicode encodings allow for a much richer amount of characters, allowing a single file to contain many languages at once, at the cost of an increase in filesize. Notepad++ will automatically try to detect the encoding used when opening a file, but allows you to change it when editing it. To simply change the displayed encoding (without modifying the actual text), select one of the Format->Encode in options from the Format menu. The convert the text to a certain encoding, select one of the Format->Convert to options in the format menu.

It can happen that a file is saved with a certain encoding, but upon reopening it in Notepad++ it is detected with another encoding. This is a technical limitation and happens because sometimes the resulting file will not differ even though different encodings are used. This is most noticeable if the file is saved without a special BOM (Byte Order Mark) indicating the used encoding.

Notepad++ offers the following encoding schemes:

ANSI
Older encoding, smallest filesize but error prone due to use of various codepages
UTF-8
Unicode encoding, most Western character take one byte of filesize, but other character can take up more, 3 to 4 most commonly. A three byte BOM will be added upon save.
UTF-8 without BOM
Like UTF-8, but no BOM is added. Saves three bytes, but makes encoding detection harder.
UTF-16 Little Endian
All characters are two bytes in size, pairs are Little Endian ordered. A 4 byte BOM is added upon save.
UTF-16 Big Endian
All characters are two bytes in size, pairs are Big Endian ordered. A 4 byte BOM is added upon save.


Searching

There are multiple methods to search (and replace) text in files. You can also mark search results with bookmarks, or highlight them.

Normal Search

Replacing

Searching in Files

Search results window

Continued Search

Volatile Search

Marking Search Results

Incremental Search

Go to dialog

Smart Highlighting

Brace Matching

Bookmarks


Normal search

You can search text as in most programs using the Find/Replace dialog. You can open this dialog by selecting Search->Find (or pressing [image]), Search->Replace (or pressing [image]) or Search->Find in Files.

Each of these options will open the corresponding tab in the Find/Replace dialog. This dialog will always stay on top of the text, but you can still keep on editing the text if it's opened, and you can set it to be transparent (using the Transparency option) when its inactive (On lose focus) or at all times (Always). The slider controls the amount of transparency. Note that transparency is only available on Windows 2000 and later.

In the Find what field, type the text you want to find. This is automatically filled with the current selected text, or the word under the caret, or the last searched pattern, when the Find dialog is opened. The drop down list contains previous search items if a search was performed before. See also Search Mode.

The section below the Find what field allows you to mark and indicate all hits for a certain search.

  • Mark Line adds a bookmark (see Bookmarks) to the line with a hit
  • Style found token will give the matching text a different color (see Marking search results)
  • Purge for each search will clear all bookmarks and highlights before searching again.

To perform any of these actions, click the Find All button in the section. To clear all the results, click the Clear button.

The In selection checkbox will restrict search to the selection. It is disabled if there is no selection.

  • Match whole word only will only result in a hit if the match consists of an entire word, not if it's partial (for example (but not limited to), whitespace separated).
  • Match case enforces that hits have exactly the same case as the query. If this is disabled, the search is case insensitive.
  • Wrap around will start at the top of the file when the end of the file is reached when searching, depending on the location of the cursor.

The search mode determines how the query will be handled:

  • In Normal, the text will be searched literally.
  • In Extended, special character sequences will be interpreted as special characters such as newline characters. In this case, you can choose from:
    • \\ - Backslash character;
    • \t – TAB character;
    • \r – CR character;
    • \n – LF character;
    • \0 – NULL character;
    • \x## - Hexadecimal value (between 00 and FF);
    • \d### - Decimal value (between 000 and 255);
    • \o### - Octal value (between 000 and 377);
    • \b######## - Binary value (between 00000000 and 11111111).
  • In Regular Expression, the query will be handled like a regular expression. Because Notepad++ makes use of the Scintilla regex engine, it is the same as with SciTE, so a full list of regex options can be found here (with the difference that POSIX mode is always on, this is not an option): http://www.scintilla.org/SciTERegEx.html with some examples here:Regular_Expressions

The search direction determines to what relative direction of the cursor will be searched. Up means text before the cursor will be searched, Down means text beyond the cursor will be searched.

To find the (next) hit, press Find Next (or Enter). Count will count the amount of hits the search will result in. Find all in all opened documents will search all opened documents and displays a list of results for each file, see also Searching in Files. Find all in current documents behaves in a very similar way.

Close simple closes the search dialog (close button and ESC do the same).


Replacing

The Replace dialog is a supplement to the Find dialog. All the same rules still apply, but now you can replace the found text with some other text., or nothing if you want to remove it.

The most important change is that the Selection only checkbox now applies to the Replace All operation. Replace All will replace all occurrences of the query with the replacement text. Replace in all opened documents will perform a Replace All operation on all the documents that are currently opened in Notepad++. Likewise, Replace in files performs a replacement across all files of a certain type(s) in a folder; it is available from the Find in files dialog, and uses all its applicable options.


Searching in Files

The Find in Files dialog searches for matches in all the files that are specified by the given filters.

The Filters input allows you to filter be name and extension, and is a space separated list. It will automatically use the extensions associated with the language of the currently opened file, but can easily be overridden (see Languages).

The Directory field will allow you to fill in the directory to search, and by default is the directory of the active file (for more info, see Preferences).

Whether the filter and search directory conform to the current document or remain what they are unless user decides otherwise is controlled by the Follow doc checkbox.

When In all sub-folders is checked, additionally all sub-directories are scanned for search results as well. When In hidden folders is checked, hidden sub-directories will also be checked (by default, these will be skipped). Find them all will initiate the search.

Results are displayed in the Search results window


Searching in Files

Search result window

The results of most searches that can return several hits will be displayed in a dockable panel (see Dockable Windows for more information). The results will be sorted on a per file and per line basis, and can be collapsed for each file (by doubleclicking the filename) (also see Folding).

Commands that make use of the facility are:

  • Find all in all opened documents in Find dialog
  • Find all in current documents in Find dialog
  • Find them all in Find in files dialog

The results in the Search results window can be deleted using the DEL key, on an individual, per file or per search basis. They can be further manipulated using the right click popup menu for the window. Additionally, the text of the window is plain text that can be copied and asted for further processing. Doubleclicking on a result will open that file and go to its location.

Search->Switch to found results window shows this window if hidden and not empty, and toggles focus between it and the main Notepad++ window. When the window is not shown, Go to Next found result and Go to Previous found result navigate among results. On earlier versions of Notepad++, the three menu entries are not there, and the names may not show on the Shortcut mapper. Default key bindings are F7, F4 and Shift+F4 respectively).

The results will be colored depending on the type of result. See Styler Configurator for information on how to change these colors.


Continued search

After a search inside a file, you can select Search->Find Next or Search->Find Previous to search for this query again. This allows you to quickly perform the same search multiple times without the need for any further input.

Likewise, select Search->Find (Volatile) Next or Search->Find (Volatile) Previous to go find the next/previous word under the carat. Or Search->Go to Next found result or Search->Go to Previous found result to navigate through results shown on the Search result window


Volatile Search

To search for the current selected text, select Search->Find (volatile) Next or Search->Find (volatile) Previous. This allows to search for text without any further input at all.


Marking search results

All->Using xxx Style, where xxx is 1st, 2nd, 3rd, 4th or 5th. To remove the marks of a given style select Search->Unmark All->Clear xxx style. It is also possible to remove all sort of markings by using the Search->Unmark All->Clear all styles. You can use the Styler Configurator to change the color of any of the mark styles.


Incremental Search

To open the Incremental Search dialog, select Search->Incremental Search. This is a fast means to find the first occurrence of some text and then find all consecutive results.

  • You can color all occurrences by enabling the Highlight All option. The color can be adjusted using the Styler Configurator.
  • If no text is found, the text area shows it by changing its background to pink - like the Firefox Search current web page control does.
  • The Match Case option only results in hits that have the same case as the query.
  • The > button searches for the next occurrence, the < button for the previous one.

Finally, the X button will close the Incremental Search dialog.


Go to dialog

To go to a certain location in the file, open the Go To line dialog by selecting Search->Go To line or by doubleclicking the location section in the statusbar (also see Status Bar). You can go to a certain line in the file or position, depending on the selection in the dialog. The Go! Button will go to that location if it's valid, the I'm going nowhere button cancels the operation.


Smart Highlighting

Smart Highighting

If smart highlighting is enabled, Notepad++ will automatically highlight all occurrences of the currently selected word. To enable smart highlighting, see Preferences. To adjust the color used, see Styler Configurator.


Brace Matching

Notepad++ can search for matching brace pairs. Placing the cursor at one brace will automatically search for the matching other brace, and highlight it (see Styler Configurator). You can move the cursor to the matching brace by selecting Search->Go to matching brace.


Bookmarks

A bookmark is a special marker on a single line, indicated on the bookmark margin. With this you can easily search for lines and perform certain operations on them.

Adding/Removing bookmarks:

You can toggle a bookmark on a single line by clicking on the bookmark margin in front of the line, or by selecting Search->Toggle Bookmark

To remove all bookmarks

Select Search->Clear all Bookmarks.

Navigating with bookmarks:

To Jump with the cursor to the next line containing a bookmark, select Search->Next Bookmark, to go to the previous bookmarked line select Search->Previous Bookmark.

Modifying bookmarked lines:

You can perform a single operation on all bookmarked lines.

  • To cut each bookmarked line, select Search->Cut Bookmarked Lines. Every line will be cut from the file and added to the clipboard, so they can all be pasted at once.
  • To copy, select Search->Copy bookmarked Lines instead.
  • To replace each bookmarked line with the current clipboard contents, select Search->Paste to (Replace) bookmarked lines. /li>
  • To remove all bookmarked lines, select Search->Delete bookmarked lines.

The Delete option allows you to search for lines first, mark them with a bookmark using search (see Search), then remove all of them based on a certain trait.


Display

The subjects described here control the appearance of the text in the screen.

Viewing modes

Unprintable Characters

Line Wrapping

Zooming

Folding

Hiding Lines

Multi View

Right-to-Left modus


Viewing Modes

Notepad++ is a Windows application, and thus can be maximised, restored or minimised (to the system tray) as such. It has two extra ways to use as much screen real estate as possible.

Using View->Toggle Full Screen Mode, the title, menu and status bar, as well as the toolbar, are hidden, and the text can occupy an extra portion of the screen, with the tab bar still visible at the top. Using View->PostIt, also a toggle, replaces that tab bar by an horizontal gap. So,what could happen enabling both? the tab bar disappears and the text ca be displayed on the full monitor height.

Combined with View->Always on Top, they contribute to make text as easy and flexibly visible as one could wish.


Unprintable characters

You can enable visual cues for displaying unprintable characters, such as space and tab, but also end of line characters (like CR and LF).

To display space and tab characters, select View->Show Symbol->Show White Space and TAB. Visual cues will be added to the document where space and tab characters are located. The color can be set using the styler configurator (see Styler Configurator).

To display newline characters, select View->Show Symbol->Show End of Line. Newline characters will be shown in boxes at the end of each line, but this does not change the editing behavior.

To display both newline characters and whitespace at the same time, select View->Show Symbom->Show all characters.


Wrapping

Line wrapping means that lines that are longer than the actual width of the screen are wrapped (that is, continued on a new line), without actually inserting any newline characters.

To enable line wrapping, select View->Wrap or press [image].

To enable a visual cue where a line is wrapped as opposed to be ended with a newline character, select View->Show Symbol->Show wrap symbol. Display of where a line could wrap because its length exceeds some theshhold can be enabled and configured in both Preferences and Styler Configurator.


Zooming

Scintilla allows to zoom in or out on the current text, without actually modifying any font properties. This allows for a quick oversight or a very clear view of the text (or both, see the screenshot and Multi-View).

To zoom in, select View->Zoom->Zoom in, press the [image] button or depress the Ctrl key and scroll the mousewheel forwards.

To zoom out, select View->Zoom->Zoom out, press the [image] button or depress the Ctrl key and scroll the mousewheel backwards.

To restore the original zoom (100%), select View->Zoom->Restore default zoom setting.


Folding

Notepad++ supports so called folding for your text documents. This means that certain lines of your text can be hidden based on certain traits. This works well for structured languages such as C++ or XML . Blocks of texts are 'parented' to others and by folding them (also called collapsing) only the first line is visible. This works well if you want a quick glance at your document and skim for a relevant position. Unfolding the text (a.k.a. Expanding or Uncollapsing) shows the text again.

You can recognize text that can be folded by looking at the fold margin on the left. This margin shows icons and line to indicate the structure of the text (the appearance of the margin can be changed, see Styler Configurator and Preferences). The current lexer determines the structure (see Languages). By default, the fold margin shows boxes and lines to indicate the structure. A box with a minus sign ( [image]) indicates the text can be collapsed. Inversely, a box with a plus sign ( [image]) indicates the text can be expanded. Folded text is additionally indicated with a horizontal line where the text is collapsed. The first line of the collapsed text will always remain visible. Lines on the fold margin indicate that the textlines they run by are foldable. Vertical lines ( [image]) indicate multiple lines that can be folded together as a group, which is terminated with a small horizontal line( [image]) or a box.

There are multiple ways to fold text.

  • The foremost means is by clicking with the left mouse button on a box with a minus sign. This will simply collapse all the text that is in this group.
  • The same procedure but with the Ctrl key pressed down will cause the group to collapse, but also any sub groups inside. This effectively means that if you were to unfold just that group, all subgroups would still be folded.
  • Using the menu:
    View->Fold All will fold every single group in the document, causing the minimal amount of text visible. View->Collapse current level will only collapse the current group (that is, the group that contains the current line, anywhere in the group). This will not collapse any subgroups. View->Collapse level... will collapse the selected level (ranging from 1 to 8). This will collapse all the groups on a particular level, but not any subgroups. You can use this to view your text with a certain 'level of detail'.
To unfold folded text, use any of the following measures: p>
  • Click on the box with the plus sign in the fold margin, this will expand that group.
  • Click on the box with the plus sign with the Shift or Ctrl key pressed down. This will expand the group and any folded subgroups.
  • Using the menu:
    View->Unfold All will expand every single group in the document, this will cause the maximum amount of text to be visible. View->Uncollapse current level will only expand the current group (that is, the group that contains the current line). This will not collapse any subgroups. View->Uncollapse level... will make every group of a certain level visible, including any parenting group.
Also note that if any change occurs in folded text, it will automatically unfold to show the text.


Hiding lines

You can also manually hide lines. To do this, select the lines to hide (all but the very first or last line) and select View->Hide lines. The selected lines will be hidden and in the bookmark margin two icons will appear ( [image] indicating the start and [image] indicating the end of the hidden section). Clicking on any of these two icons will show the lines again.


Multi View

You can enable a secondary edit window in Notepad++ to be able to view two documents at the same time (possibly the same). If used with the same document, you can quickly compare two documents or make quick changes in two places at the same time without having to scroll or keep bookmarks.

To use Multi View, first activate the document that you want to view in the other view. Then, you have two options:
Select View->Move/Clone current document->Go to another view, this will move the document to the other view, closing it in the first view.

Select View->Move/Clone current document->Clone to another view, this will clone the document into the other view, linking the two. Any change in the first document will automatically be forwarded to the second and vice versa. You can also reach these command by right-clicking on the tab of a document and selecting the command from the context menu.
Note that these options are also available by dragging a tab into an edit field, with the Ctrl depressed for cloning and not depressed for moving

Once you have Multi View enabled, you can control its layout. You can drag the divider around using your mouse, or click on the small arrows on the top and bottom to completely move it to the left or right. Rightclicking on the divider shows a popup menu allowing you to rotate the layout for a horizontal or vertical version.

Although you can view two documents at the same time, only one can be active (have the focus). You can determine the active view by the tabbar if you have the topline enabled (see Tab bar). By default, the active view has a darker color of orange than the inactive view. Also, only the active view can have the caret. You can switch the active view by selecting View->Focus on other view. The active view determines what options are available from the menu or toolbar. If the main view has a saved document, but the secondary view is modified, you can only select the Save option if you have the secondary view active.

If you have the same document open in two views, they will share some properties, but some of them can be modified independently. These include:

  • Folding (but not line hiding).
  • Zoom level;
  • Scroll position;
  • Cursor position;
  • RTL modus (see RTL).

Additionally, each view can have its own properties which can be set in the Preferences -> Settings -> Editing tab, use the dropdown list to choose between the views. Each view can also independently show unprintable characters, determine the linewrapping modus and control the overtype option.

If you open a new document or a file, it will do so in the currently active view. Additionally, closing the last document of a view will close that view if two views are visible (including moving the last document of one view to the other).

To ease document comparison/navigation, you can enable scroll locking in Multi View. When a lock is enabled, scrolling one view will automatically scroll the other. The lock will attempt to keep the current offset. This means if one view is scrolled 5 lines lower than the other, the vertical scroll lock will keep this distance unless this is not possible anymore. Is soon as it is possible it will retain the offset again.

To enable horizontal scroll locking, select View->Synchronize Horizontal Scrolling or press the [image] button.

To enable vertical scroll locking, select View->Synchronize Vertical Scrolling or press the [image] button.


RTL

Right-to-Left (RTL)

Notepad++ support both Left-to-Right (LTR) and Right-to-Left (RTL) environments. The main user interface determines the layout using the translation file (if the file contains the 'RTL=”yes”' attribute in the 'Native-Langue' tag, it will enable the RTL UI, otherwise it will be LTR).

Each View can also independently set the RTL or LTR mode, simply select View->Text Direction LTR for LTR text display and View->Text Direction RTL for RTL text display. Please note that Scintilla currently has issues with RTL text display for LTR text and indicators (especially if RTL and LTR are combined).


Macros

Notepad++ is capable of recording some of your actions you perform while editing a document, and replaying those later on to avoid having to repeat that sequence of actions. This is called a macro and can save a great deal of time. Macro's can be played once, or multiple times, even as long as is required to run through an entire document. You can save them for later use and assign keystrokes to them for fast access (See Shortcut Mapper). Macro's are sensitive to the current position of the cursor and will (normally speaking) operate relative on it.

To record a macro, select Macro->Start Recording or press the [image] button on the toolbar. Notepad++ will now keep track of the changes you make on a document or certain actions you perform.

To stop recording, select Macro->Stop Recording or select the [image] button on the toolbar. As an exception to most commands, you can toggle this behavior with a special shortcut combination that is not listed in the menu but solely in the Shortcut mapper (see Settings, Shortcutmapper). By default, this is the combination Ctrl-Shift-R.

After the recording is stopped, it will be stored in a temporary buffer. If you haven't performed any actions, this buffer will be cleared. If you start recording another macro without saving your earlier work, it will be lost.

To play the macro in the buffer, select Macro->Playback or press the [image] button. This will perform the macro once at the current position.

To save the macro in the buffer, select Macro->Save current recorded macro or press the [image] button. A dialog will pop up asking for a name of the macro and the default key combination. These can later be changed (and deleted) using the Shortcutmapper (see Shortcut Mapper). When saved, the macro will be available from the Macro menu or the Macro playlist.

To play the current macro in the buffer or any saved macro once or multiple times, select Macro->Run a macro multiple times... or press the [image] button. A dialog will pop up allowing you to select what macro to perform (buffer macro or any saved macro) and how many times. You can also opt to perform the macro until the cursor reaches the end of the current file (starting from its current position). Note that if no macro's are available, this dialog is inaccessible.

Currently (v5.4.3), macro's cannot save Find(/Replace) operations.


Commands

Commands allow you to execute applications from Notepad++, for example to open your current file in a browser or compile it with some external compiler. You can pass the program command line parameters based on the current status of your document.

To run a new command:

Sselect Run->Run.... A dialog will pop up asking for the path to the program and possible any command line parameters. You can use the browse button to search for your program. The drop down list provides recently run programs. The command line arguments can also be based on the status of the current document, and are always enclosed in $(...), where … can be:

FULL_CURRENT_PATH
the fully qualified path to the current document.
CURRENT_DIRECTORY
The directory the current document resides in.
FILE_NAME
The filename of the document, without the directory.
NAME_PART
The filename without the extension.
EXT_PART
The extension of the current document.
NPP_DIRECTORY
The directory that contains the notepad++.exe executable that is currently running.
>CURRENT_WORD
The currently selected text in the document.
CURRENT_LINE
The current line number that is selected in the document (0 based index, the first line is 0).
CURRENT_COLUMN
The current column the cursor resides in (0 based index, the first position on the line is 0).

For example,

"$(NPP_DIRECTORY)\notepad++.exe" -multiInst "$(FULL_CURRENT_PATH)"

would start a new instance of Notepad++ opening the current file. Remember to put quotes around paths if it can contain spaces. For the Notepad++ command line options, see Command Line.

To run an existing command:

Select it from the Run menu below the Run... option. If no commands are saved, the list will be empty.

To save the command:

Sselect Run->Run..., enter the command and press Save.... A dialog will pop up asking for a name of the command and the default key combination. These can later be changed (and deleted) using the Shortcut Mapper (see Shortcut Mapper). When saved the command will be available from the Run menu.


Windows Dialog

The Window menu allows you to select a file from the list of the first 10 open documents in the active view (see also Multi View). Selecting a document from the list will activate it. p>

You can open the Windows dialog by selecting Window->Windows.... The Windows dialog allows you to manage all the currently open documents of the activate view.

The Windows dialog shows a list of all the open documents in the active view. You can select one or more documents from the list. Like any Windows list control, select multiple by dragging during clicking with your mouse, or by pressing Ctrl or Shift when selecting by clicking. Or use the arrow keys on your keyboard optionally with the Ctrl or Shift key depressed (if you do so, use the spacebar key to select).

Selecting one allows you to activate it by clicking on the Activate button. This will close the dialog.

Selecting one or more allows you to click on the Save button, this will perform the Save operation if possible on all selected documents (if a Save As.. operation is needed, nothing will happen (see File Management, Opening and Saving)).

Selecting one or more also allows you to close those documents by clicking on Close Window(s). If a document contains any changes, you will be asked if you want to save them.

To sort the documents using the dialog, first sort the list by selecting one of the column titles in the top (selecting twice inverts the sort order). After doing so, select Sort Tabs to sort them, the documents will be rearranged in the view.

Click OK to close the dialog.


GUI elements

The main Notepad++ view consists of a few GUI elements. These sections elaborate a bit on them.

Tab Bar

Status Bar

Tool Bar

Menu

Context Menu

Dockable Windows

Menu Tool Bar Tab Bar Status Bar Context Menu


Tab Bar

Each view has (by default) its own tab bar. The tab bar allows you to select between different documents, and arrange them. For the tab bar configuration options, see Preferences. The tab bar shows for each file its name and a little icon indicating the status of that file. A blue disk ( [image]) means the file is not modified (or it is a new document). If the disk is red ( [image]) it means that the file has been modified and these changes have not yet been saved. A grey disk ( [image]) means the file is marked as read-only and cannot be modified (see Read-Only). If more tabs are visible than can be shown on the display, then:
  • If you did not enable multine tab bar from Preferences, two small arrows appear on the right, allowing you to scroll through the tabs to find the correct one.
  • If you did, then several rows of tabs will be visible.
The active tab can show an orange line (enabled by default). If two views are enabled (see Multi View), the tab with the darker shade of orange is the active one. You can control the colors the tab bar uses using the Styler Configurator.

You can reach the tab bar context menu by rightclicking on a tab. This context menu allows quick access to certain commands for managing your files, getting and setting file properties and moving the tab to other views.


Status Bar

The status bar shows additional information about the currently active document and consists of six sections.

  • The first section shows the current language that is selected for that document (see Languages).
  • The second section shows the amount of characters (in bytes) that the current document contains. This is not equal to the filesize of the document (except for ANSI documents), but the internal size (see Encoding for more details).
  • After that you find information about the cursor in the document. It consists of the current line ('Ln', first line is line 1), the current column ('Col', first position is 1) and the length of the selection (in bytes, see Encoding). If you doubleclick on this section, the Go to Line dialog will pop up.
  • The fourth section shows the current newline format (see Newline format).
  • The fifth section shows the current character encoding of the document (see Encoding).
  • The sixth and last section shows the current overtype status of the active view. INS means insertion and OVR means overtype (see Overtype for more information). Clicking on this section switches between insertion and overtype typing mode.


Tool Bar

The tool bar allows for quick access to certain menu commands (including those of plugins if they are registered, see Plugins). If the screen is smaller than the toolbar width, then some of its buttons will be hidden. You can access these buttons by clicking on the chevron (the double arrows) on the right of the toolbar, a menu will pop up showing you the hidden commands. You can customize the toolbar to use different icons. Notepad++ supports three modes:

  • Standard icons: this is the default. These icons are small and also include the plugin icons.
  • Big Icons: This shows larger icons, which can be changed into custom icons. They have different images for highlighted or selected buttons.
  • Small Icons: The same as big icons, but now with the size of the standard toolbar icons.

To choose which mode to use, see Preferences.

To load custom images for your toolbar, you need a special configuration file and the custom images. To learn how to use these, please see the following link for information:
http://sourceforge.net/apps/mediawiki/notepad-plus/index.php?title=Toolbar_Customisation


Menu

The main menu contains all the commands Notepad++ can offer (with the exception of most of the Scintilla commands, which are accessible by their shortcut keys, see Shortcut Mapper for details).

For each item in the menu (with a few exceptions), there can be a shortcutkey assigned. If this is the case, it will be shown next to the name of the command. You can type this combination of keys instead of selecting the command from the menu for quick access. To change these shortcuts, simply use the Shortcut Mapper


Context Menu

The context menu can be reached by rightclicking anywhere in the edit screen. The context menu allows for quick access to commonly used commands and is user configurable. To change the contents of the context menu, you have to edit the contextMenu.xml file. For this we refer you to
NpWiki++


Dockable Windows

Notepad++ supports so called Dockable Windows. These are part of the GUI, but you can move them around and choose whether you want them aligned to any side of the main windows (docked), or floating like a separate window.

To change the location of a dockable window, click and drag the titlebar of the window around. When you drag near any edge of the main window, a rectangle will be drawn indicating that the window will be docked there if you release it. Moving it anywhere else will draw the rectangle in the same way the window would be positioned if it were floating.

You can resize floating windows like any other window by dragging its edges, but to resize a dockable window you have to drag the edge that is adjacent to the main window.

There can be multiple dockable windows grouped together. If this is the case, only one of the windows is shown, and the others are reachable by a tab bar that is shown below the visible window. Selecting an item from the tab bar will hide the visible window, and show the corresponding window from the tab bar. You can recognize the dockable windows in the tab bar by their icon.


Switching between Documents

For switching between documents the foremost method is by using the tab bar. However, you can also use the keyboard or mouse to do so. By default, you can switch to the next document by depressing the Ctrl key and then pressing Tab once for each next document. Pressing shift as well will select the previous document. To use the mouse, depress the right mouse button and use the scroll wheel. Scrolling up will select the previous document, scrolling down the next. The order of the documents is derived from the tab bar. See Tab Bar or Windows Dialog for information on how to change it.

Documents will by default be cyclically selected, meaning that if you select the document past the last one, the first will be selected. If two views are visible, the first document of the other view will be selected.

Selecting the document previous to the first document will select the last document (if two views are visible that will be the last document of the other view).

Document Switcher

MRU


Document Switcher

The document switcher is a small list of currently opened files that is shown (if enabled, see Preferences) when you switch documents, allows you to select what document to activate before actually doing so. The list will remain visible until either you release the modifier key that triggered the list (Ctrl key if using the TAB key or the right mouse button if using the scroll wheel) or one of the documents has been selected by clicking on it with the left mouse button. The highlighted document will then be activated.

Please note that if you assign anything else than Ctrl-(Shift-)TAB to switching documents, the document switcher will not work properly when switching using the keyboard. In that case, use the mouse or disable it (v5.4.3).


MRU

MRU (Most Recently Used) switching

Notepad++ can provide MRU behavior for switching between files. MRU stands for Most Recently Used and means that the first file to be activated, is the last one active before the current document. This will put often used files to the top and less used files to the bottom (If you are familiar with the Windows Task Switcher, the behavior is similar). MRU is only available when the Document Switcher is enabled.


Languages

Notepad++ can distinguish between different languages source code can be written in. This is useful to allow certain modifications and visual aids to be applied specifically designed for that language. For example, a language could distinguish certain keywords that have to be differently interpreted, and as such it can be useful to distinguish these keywords using another color or font. The language also determines the folding behavior (see Folding) and how to handle comments (see Commenting).

Notepad++ offers a lot of languages that can be selected, and has a few methods to add your own as will be discussed.
By default Notepad++ will try to guess the language of a document by the extension of the filename (if it is a file) or the default setting if it is a new document (see Preferences). To select another language, simply select it from the Language menu. The language of the currently active document is visible in the status bar in the first section (see Status Bar). By default a language can have multiple keywords, divided in certain categories. It also determines the symbols used for comments and what extensions are associated with it by default. You can supplement the keywords and the list of extensions using the Styler Configurator, it also allows you to change the colors used to print the text.

If you like to define your own language, you can do so by two means. The most simple and straightforward method is to make user of a User Defined Language (see User Defined Languages), but you can also create your own external lexer (see External Lexers). This is more flexible but also a lot more difficult to make.


Built-in languages

Standard Notepad++ comes preloaded with a list with some of the most popular languages. You can select those languages using the Language menu and configure their style using the Styler Configurator. Most often the correct language is selected when opening a file based on the extension or filename (as is the case for makefiles) but you can always select another one. When saving a session, the selected language will be remembered, but closing and reopening the file will trigger the autodetection again. You can change the extensions that are associated with a language using the Styler Configurator. Also, custom keywords can be added to most languages: when selecting an adequate (language, style item) pair, the Styler Configurator displayys a text area where extra keywords can be typed in, separated with spaces.


>User Defined Languages

User defined languages allow you to add your own language to Notepad++. This is a very quick and easy way to do so. Notepad++ always has the main User Defined language available. You can use this to test your settings and then later on create a new language based on this. The User Defined language gets reset each time you restart Notepad++, its settings will not be saved. User defined languages are available from the bottom of the language menu.

To define one, you need the User Defined Dialog, which can be accessed by selecting View->User Define Dialog... or pressing the [image] button.

The dialog can float like any regular dialog when open, or be docked in the main Notepad++ window. Simply click Dock/Undock to do so. If the dialog is undocked (floating) you can control its transparency. Enable the transparency checkbox and control the amount using the slider. Note that transparency is only available on Windows 2000 and later.

The dialog shows a dropdownlist of the currently defined user languages. Select one to change its parameters, if possible they will be automatically saved. To create a new user language based on the current state of the main User Defined language, click the Create New... button, a dialog will pop up asking for the name. To create a new User language based on the currently selected language, click Save As... and enter the new name. If you have selected an user created language, you can click on the Rename button to enter a new name if necessary, and the Remove button will delete the language.

If you want the user language to ignore the case of the text (so it will be case insensitive when looking for keywords), enable the ignore case checkbox.

For user created languages, you can also define what file extensions to associate with them for language autodetection in the textbox with the Ext label.

Most settings have a certain text style associated with them. These work the same as in the Styler Configurator (see Styler Configurator for details).

Other aspects of the language are controlled by the settings divided in four groups:

Default style and Folding (Folder & Default tab)

This tab control the style of the default text (text that has no special attributes or meaning) and the keywords that control the folding. A keyword in the Folder Open group will trigger a new Fold group that can be expanded and collapsed. A keyword in the Folder Close group will close any opened group.

Keywords (Keywords Lists tab)

This tab controls what keywords are registered with the language. You can define up to four groups of keywords, each with their own style. If you enable the Prefix option for a group, that means that these keywords can be prefixes of entire words, and thus will be detected even if the keyword is directly followed by other text. In that case the other text will be styled the same as the keyword.

Comments/Numbers (Comment & Number tab)

This tab controls the behavior and appearance of comments, and the appearance of numbers. You can define multiple comment symbols that are comment line symbols. These comments run from the symbol itself to the end of the line. You can also define comment block symbols. These symbols start commenting from any comment open symbol, until and comment close symbol is reached.

If you enable the Treat keyword as symbol checkbox, the comment symbols also trigger comments if they are the beginning of a word, much like prefix keywords.

Numbers are only recognized if they start a word with characters ranging from 0-9, where only the number symbols are styled as such.

Operators and Delimiters (Operators tab)

This tab controls what operator symbols exists and what symbols act as delimiters. Operator symbols are characters that split two words. They behave much as whitespace but can be styled differently.

Delimiters are single characters and usually defined in pairs. Any text between a pair of delimiters as styled as such. A good example is a string, which is delimited on both sides with double quotes and drawn in a different color. Since, in many languages, a string may contain the string delimiter with a special prefix, you can enable and choose this prefix, the escape character.


External Lexers

External lexers are like built-in languages, but are provided by means of a plugin (see Plugins for details). This allows to user to add powerful syntax coloring and folding, but are harder to make. Installation goes the same as for regular plugins, and you can select them from the Languages menu, they will be at the bottom.


Settings

Control many the aspects of Notepad++. They are divided in three main groups:

Preferences

Styler Configurator

Shortcut Mapper

The Shortcut Mapper is a list of keyboard shortcuts to everything that can have one in Notepad++. Styler Configurator allows changing the visual appearance of anything that has a colour or a font. The Preferences dialog manages everything else. While there are various aspects in Notepad++ that are not configurable, you may not even notice them.


Preferences

You can configure many aspects of Notepad++ using the Preferences dialog. The dialog consists of multiple tab which contain options that are relevant to some aspect of Notepad++ (for instance, the interface or backup options).

General

The general settings control the look of the main interface. You can control the Tab Bar, the Tool Bar, the Status Bar and the menu from here, as well as the current ...

Localization:
This dropdown list shows all the languages which you can use for Notepad++ to speak your language. If you click on one of these languages, all user interface elements are instantly translated into that language. The various localisation files are in the Localization subfolder of Notepad++'s install folder.
Tool bar:
  • Hide - Check the hide checkbox to completely hide the tool bar. The following choices show immediate results, but sometimes a restart is required to load the correct icons:
  • Small icons - Notepad++ will use the small icon set for the toolbar. This can be the built-in icon set or custom icons.
  • Big icons - Notepad++ will use the large icon set for the toolbar. This can be the built-in icon set or custom icons.
  • Small standard icons - These are the default built-in icons. This is also the only option that will show any tool bar icons registered by plugins.
Menu bar:
Hide - If you check this option, the menu bar will automatically hide. To (temporarily) show the menu bar, press the Alt key or the F10 key to give the menu focus. Selecting an option, pressing escape or giving another window the focus will hide the menu again.
Status bar:
Show status bar - Check the option to show the status bar.
Tab bar:
  • Hide - Checking this option will hide the tab bar. You can still open multiple documents but you have to switch using shortcuts rather that using the tab bar.
  • Multi-Line - Checking this option will cause the tab bar to draw multiple rows of documents if they cannot all be displayed in a single row. Otherwise a pair of scroll arrow buttons will appear. Note that the active document will always be on the bottom row.
  • Vertical - Checking this option will rotate the tab bar 90° counterclockwise and place it at the left side of the screen.
  • Reduce - If checked the tab bar will use the default font and icon size. Unchecking will cause it to use a larger font and larger icons.
  • Lock - Checking this will disable the ability to sort documents by dragging the tabs around.
  • Draw the inactive tabs - If checked, inactive tabs will be drawn using a custom background color (see Settings, Styler Configurator).
  • Draw the orange top bar - Checking this will draw a (by default) orange line on top of active tabs (see Settings, Styler Configurator).
  • Enable close button on each tab - Checking this will add a close button on each tab. Clicking it will close that tab.
  • Double click to close document - If checked, doubleclicking on a tab will close it.

Editing

These settings affect the behaviour and look of Scintilla, the edit component of Notepad++.

Caret settings
  • Width - Set the width in pixels of the caret, or change it into a block which is the size if the current character (if printable, otherwise the size of the space character).
  • Blink rate - Change from fast (F) to slow (S). Moving all the way to slow will stop the blinking.
    You can change the caret color with the Styler Configurator.
    • Multi-Editing
    You can enable or disable this feature through the checkbox. This both controls the ability to select multiple areas (see Selecting text) and to get typed text mirrored in all the areas in the selection.

    The following options are changed per view (See Multi View). Select the view to adjust form the combo box.

    Folder margin style
    The style of the icons that indicate folding (See Folding). Select from 4 types.
    Vertical Edge Setting
    • Show vertical edge - Checking this will draw a vertical edge throughout the document. Mode
    • Line mode - If this mode is set, the edge will be drawn using a line in the background
    • Background mode - If this mode is set, the edge will be drawn by changing the background color of characters that are past the edge. You can change the color with the Styler Configurator.
    • Number of columns: The distance in columns (as determined by the size of the space character) at which the edge will be drawn.
    Other options
    • Display line number margin - If checked, line numbers will be drawn. You can change the color with the Styler Configurator. When shown, the line number margin can accommodate three digits, and will grow as needed to display numbers in a higher range.
    • Display bookmark margin - If checked, the bookmark margin will be drawn.
    • Active current line highlight - If checked, the line at which the caret is present will be drawn with a special background color. You can change the color with the Styler Configurator.

    New Document/Open Save directory

    These options change the way new documents are created and what the default Open/Save directories will be.

    New document:
    • Encoding: Allows to choose what encoding to use (see Encoding).
    • Format: Allows to choose what end-of-line format to use (see Newline Format).
    • Default language: defines which highlighter will be used for any newly created document. The dropdown list mirrors the Language menu. However, user defined languages and external languages cannot be selected.
    File Open/Save Directory:
    The File Open/Save Directory, or Default Directory, controls what directory Notepad++ looks in when opening or saving files. Please note that the Default directory is not the same as the Current Directory (Working Directory) Notepad++ uses. Do not make assumptions about Notepad++ Current Directory.
    • Follow the current document - If this option is selected, the default directory will be the directory of the currently active file. If the file is a new, unsaved document, this will be Notepad++' directory.
    • Remember the last operation directory - If this option is selected, the default directory will initially be the directory Notepad++ was started in (you can control this by adjusting the shortcut you use for Notepad++) and only change when browsing for files (to open or save a file).
    • Custom - The default directory can be set to a fixed path. Browse for a path or type it yourself. If the path is invalid, Notepad++' directory will be used. You are allowed to use Environment Variables, using the $(var-name) syntax as usual.

    File Association

    You can associate files with Notepad++ so opening those files will start Notepad++. Select a type of file, then select the desired extension and press the left arrow to associate the file. To add a custom type of file, select customize, enter the extension and press the -> button. To remove the association, select the extension to dissociate and press the arrow next to the garbage can.

    Language Menu/Tab settings

    You can select the languages that are available from the Language menu. In the Available Items list are the languages that are currently visible. To hide a language form the menu, select it and press the -> button to put it in the Disabled Items list. Add the language again by selecting it from the Disabled Items list and pressing the <- button.
    The appearance of the Language menu can be further controlled by the Make Language menu Compact checkbox. When checked, languages whose names start by the same letter are grouped into a submenu, rather than being all lumped in the menu proper.

    Tab settings can be adjusted on a per language basis. The right hand list has all built-in languages, as well as a topmost (Default) entry. The latter applies to all languages which don't have a custom setting, as well as to all user defined languages. The frame below allows adjusting tab settings for the selected language:

    • Tab size - Size in space characters of a tab character in the document.
    • Replace by space - Checking this will cause any tabs added to be in the form of spaces, up to the amount as determined by the Tab size setting.

    Print

    Use these settings to adjust the layout and colors used when printing a document, as well as the page header and footer text. This can be any regular string or a variable that will change depending on the printed document.

    • Print line number - If selected, linenumbers will be printed aswell.
    • Colour Option:
      • WYSIWYG - print colours exactly as they are on the screen.
      • Invert - This will print the document with the background color inverted (white becomes black for instance, and v.v.) and the default foreground color inverted. All other colors will remain the same.
      • Black on white - All text will be printed black and a white background.
      • No background color - This will print all the text colored, but any background colors (including the default color) will be printed white.
    Variables
    You can use Variable: variable text inside the current header/footer. There are a few default variables listed, but you can also use any variable used by the Run dialog (see Commands) as well. The syntax is the same. To add some predefined variable from the dropdown, click Add. The name will automatically be escaped.
    Header:
    Control the header text. If any header text is present, it will be separated from the document with a line. Use the various edit controls to adjust the text added to the header. You can add text in the left aligned, right aligned and centered sections. The controls below control the font used by the header.
    Footer:
    Control the footer text. See Header for more information.

    Backup/Auto-Completion

    Backup:
    Control backup behaviour. You can instruct Notepad++ to automatically make a backup of every file if you save any modifications.

    • None - No backups are made.
    • Simple backup - A backup is saved to a file with the same name and .bak added as extension (the original extension is preserved).
    • Verbose backup - Like simple backup, but before the .bak extension a short date and timestamp is added.
    • User custom backup directory - If checked, a custom backup directory is used instead of saving to the same directory the file resides in. If the path is invalid the directory the file resides in will be used.
    Auto-completion:
    See Auto-Completion on what Auto Completion is.
    • Enable Auto-completion on each input - If checked, Notepad++ will try to autocomplete the current word being typed based on how much is already written.
      • Function Completion : try to complete the current word using the list of functions of the current language.
      • Word completion : try to complete the current word using the words in the document.
      • From #th characters: Enter amount of characters needed before Notepad++ tries to auto-complete the current words. Allowed values range from 1 to 9.
    • Function parameters hint on input - If checked, when a character is added that marks the start of a list of arguments of the currently typed function, the function parameters calltip will be shown.

    MISC

    These settings control other aspects of Notepad++.

    History File Setting:
    • Max number of history file # - Any number from 0 up to 30. Controls the amount of files that are saved in the history.
    • Don't check at launch time - If checked, Notepad++ will not verify the validity of the files in the history. If unchecked, Notepad++ will check the existence of each file. Recommended to be turned on in case of networked files.
    Document switcher: (See Document Switcher)
    • Enable - Enable the document switcher.
    • Enable MRU behavior - Enables the MRU style sort of files in the document switcher.
    Clickable link settings:
    This feature optionally makes web addresses starting with http:// clickable. Double clicking opens that address in your browser, if any is installed and registered.
    • Enable - If enabled, http:// addresses are clickable as soon as they have been typed and caret leaves them.
    • Don't draw underline - If enabled, the address will be drawn without an underline. Underlining is the default.
    File Status Auto-detection:
    Automatically checks the status of each opened file when Notepad++ is activated from the background.
    • Enable - Check to enable status detection.
    • Update silently - If a change to a file is detected (modified contents), Notepad++ will reload the file without asking.
    • Scroll to the last line after update - If checked, when a file is reloaded after an external modification is detected, it will be scrolled to the last line (useful for tailing log files).
    Highlight matching tags:
    Tag highlighting is used for HTML/XML languages. When the cursor is located inside or at a tag, corresponding tag entries will be colorized. Change the colors using the Styler Configurator.
    • Enable - Check to enable tag highlighting.
    • Highlight tag attributes - If checked, the attributes of a tag will be colorized as well.
    • Highlight comment/php/asp zone - If checked, tags inside a php/asp zone will be matched as well.
    Sessions
    • Remember the current session for next launch - If checked, the all the files opened in Notepad++ will be opened again if Notepad++ is closed.
    • If an extension is entered in Session file ext, Notepad++ will try to open these files as session files instead of regular files. This allows you to simply provide a session file via the command line or any other method of opening a file to load a session into Notepad++.
    Other options
    • Enable Notepad++ auto-updater: If checked, Notepad++ will attempt to find about an update at startup. You have the option of postponing the upgrade if one is found.
    • Auto-indent - If checked, adding a new line will automatically indent that line if any line with text before it has indentation as well. The indentation will then be matched.
    • Minimize to sys tray - If checked, minimizing Notepad++ will cause it to be hidden from the taskbar and an icon to be added to the system tray (notification area). Clicking the icon will bring Notepad++ back to the foreground.
    • Smart highlighting - If checked, any word that matches the currently selected word in the screen will be highlighted. You can control the color using the Styler Configurator.
    • Show only filename in titlebar - If checked, instead of the full path to the active file only the filename will be displayed.


Styler Configurator

The styler configurator is primarily used to control the appearance of the text in Notepad++, but it also allows you to tweak some of the other aspects that have a user configurable color.

The styler configurator has two lists. The left list (Language) contains all the languages that can be styled, as well as other items with some color setting:

  • Global Styles: controls the user interface colors.
  • Search results: The text of the Search results window
  • DOS style: Highlighting text as if displayed on a command.vom/cmd.exe shell window.

The list on the right (Style) has all the configurable styles for the selected language.

For most languages it is straightforward what each property does, so only the global setup and the exceptions are mentioned here.

Validation:
  • Save & Close: Store all style information and close the dialog.
  • Cancel: Revert any changes made and close the dialog. Same as closing the dialog.
Dialog options:
Transparency enable transparent dialog. The slider controls the amount of transparency. Note that transparency is only available on Windows 2000 and later.
Style themes:
A style theme is a complete collection of style properties (see below), foa all languages and global settings. At any given time, one theme is active, and you can change it at any time using the dropdown list at the top of the dialog. The list is read at startup from the themes\ configuration subfolder, but you can add to it later using the Preferences -> Import -> Import theme file(s) command.
Style properties:
All styles have some properties assigned to them. Som styles have properties that others do not have, such as a background color. If a property is not available it is simply greyed out.
Colors:
Clicking on the color box shows a popup with a few default colors. Clicking on those will change the color to that. Click More Colours... to manually specify a color. Either color can be rightclicked upon, if enabled, to leave the color property 'blank'. The style will then use the default color instead.
  • Foreground color: The 'main' color. For text this is the color of the characters.
  • Background color: For text this is the background 'filler' color.
Fonts:
  • Font Name: The font to use when drawing the text. Leave blank to use the default.
  • Font size: Size of the font (in points) to use when drawing text. Leave blank to use the default.
  • Bold: Check if you want to use bold text.
  • Italic: Check if you want to use italic text.
  • Underline: Check if you want to use underlined text.

If a regular language is selected, two edit controls are shown:

  • Default ext.: default file extensions associated with this language. If a file is opened with that extension, Notepad++ will switch to that language.
  • User ext.: user definable list of extensions (space separated).

When a style is selected that has special keywords assigned to it, selecting that style will also display two extra edit controls:

  • Default keywords: These are the keywords used by default of the given language.
  • User Define keywords: These are (space separated) keywords you can enter yourself to supplement the default ones. The style will then only be applied if a word in the text equals to the keywords (variations can occur depending on the language, because syntax can be different).

Special languages:

Global Styles: (default styles + user interface styles)

Global Override
This style can override every single other style, and has a few options beside the default style properties. Each checkbox below the default styling options specifies what global property to apply. If a property is blank the style will not be applied (however bold, italic and underline do globally disable those properties if unchecked but enabled).
Default Style
Default style properties to base other styles on. Leaving properties blank results in undefined behavior.
Indent Guideline
Colors to use for the indent guideline. The guideline is made of alternating colors, these can be specified using the fore- and background color options.
Brace Highlight Style
Highlighted braces use this style. All properties can be adjusted.
Bad brace colour
If brace highlighting fails because no matching brace can be found, the brace is drawn with this style.
Current line background colour
Control the background color of the active line highlight if it is enabled. Cannot be set to blank value.
Selected text colour
Color of the background of selected text. Cannot be set to blank value.
Caret colour
Color of the caret. Cannot be set to blank value.
Edge colour
Color of the vertical edge. Cannot be set to blank value.
Line number margin
Controls the style of the line number margin. All properties can be adjusted. This also controls the background of the bookmark margin.
Fold
Controls the color of the fold indicators (not the margin itself). Cannot be set to blank values.
Fold Margin
Controls the colors of the fold margin background. Fore- and background color alternate in a checkerboard pattern with each pixel.
White space symbol
Controls the foreground color of whitespace. This is only visible if the drawing of whitespace characters is enabled or any style that is applied to whitespace is set to underlined. Cannot be set to blank value.
Smart Highlighting;
When enabled, applies to all occurrences of the text beeing selected.
Mark style #
# is between 1 and 5. This setting will define the highlighting used in conjunction with Search-&gr;Mark All->Using #st style
Find Mark Style;
When Style token found is checked on the Find dialog, and the Find all is executed, applies to all occurrences of matched pattern.
Incremental highlight all;
Applies when incremental search is in progress.
Tags match highlighting;
When enabled, applies to the tags that match.
Tags attribute
Controls the background color used for said property. Cannot be set to blank value.
Active tab focused
Determines the color used fore the line (if enabled) drawn on the active tab of the active view. Cannot be set to blank value.
Active tab unfocused
Determines the color used fore the line (if enabled) drawn on the active tab of the inactive view. Cannot be set to blank value.
Active tab text
Foreground color of the text for an active tab. Cannot be set to blank value.
Inactive tabs
Foreground color controls the color of the text of inactive tabs. Background color controls the color that is used to fill the tab with if inactive tabs, if drawing of inactive tabs is enabled.

Search result

Controls the appearance of search results when shown in the search results window:

Default:
All text in the window which is not highlighted uing another style
Search Header
The topmost line, wich shows the search pattern, number of files and number of hits
File Header
Shows the file name and number of hits on that file
Line Number
Clickable line numbers which lead straight to the match
Hit Word
The match itself
Selected Line
Any selected text
Current line background colour
How this line shows. Right click the color to suppress this highlighting.

Dos Style

The Dos language uses a special font called MSLINEDRAW to enable “box-art” for files written in the old Dos codepage. You can only control the fore- and background color of the text (applied to all the text). The font properties are derived from the default style (with the exception of the font name, which is always MSLINEDRAW).


Shortcut Mapper

The Shortcut Mapper controls the keyboard shortcuts assigned to commands from the menus and the Scintilla control. Pressing such a shortcut will trigger the command. Menu shortcuts have a one-to-one mapping, meaning that a menu item can have only one shortcut, and no duplicate shortcuts are allowed (you can enter them, but only one will work, so be careful with conflicts). Scintilla shortcuts have a one-to-many mapping, meaning a single Scintilla command can be triggered by multiple shortcut combinations. However, the same shortcut for multiple commands is not allowed, just as with the menu.

Shortcuts are listed in a two column list. The left column shows the name of the command, the right column the associated shortcut, if any. When viewing shortcuts, doubleclicking on it or rightclicking and selecting Modify allows you to change it. You will get an dialog with the name (modifiable for macros and run commands) and the assigned shortcut. Use the checkboxes to control what modifier keys to use (note that Scintilla does not support the Windows key, as it hardly makes sense on a Unix/Mac machine) and the dropdownlist to choose the key to press. Selecting 'none' from the list will disable the shortcut key (a warning will appear). Pressing OK applies any changes, Cancel or closing the dialog aborts.

The dialog for Scintilla shortcuts is a bit different because you can add multiple shortcuts. In addition to the normal controls, you will find a listbox with all the assigned shortcuts (if any). The Add button will add the current entered shortcut if not 'None' and not already in the list. The Remove button will remove the selected shortcut from the list (you can remove all but the last).

The Apply button will change the currently selected shortcut to the current settings. To remove a shortcut if more than one is present, use the Remove button. To remove a shortcut if it is the only one, set it to 'None' and Apply

The OK button will save any added or changed shortcuts, but you have to specifically perform the change before it is saved. >p>In all cases, if a shortcut is determined to be invalid, you cannot press OK or Apply to add or modify the shortcut.

The shortcuts are divided in multiple categories:

Main Menu:
These shortcuts control the default main menu commands. Additionally you can change the shortcut for switching between documents, but this is not recommended (there are still issues with this if you use some other modifier than the Ctrl key).
Macros:
Shortcuts for recorded and saved macros. You can edit the name of the macro as well. You can also delete Macros from here by rightclicking on the macro and selecting delete.
Run commands:
Shortcuts for saved commands. You can edit the name of the command as well. You can also delete Run commands from here by rightclicking on the command and selecting delete.
Plugin commands:
Shortcuts for plugins. By default a plugin can opt for a shortcut combination but you can manually add or override it here. See also Plugins
Scintilla commands:
Shortcuts for Scintilla. Only the primary shortcut is displayed in the list, but when editing the command all of them will be listed.


Plugins

Notepad++ is very extensible using so called plugins. Plugins are small or big additions to Notpead++ to enhance its functionality. Notepad++ comes bundled with a few plugins (when using the installer, you can choose which ones to add), but you can always add your own or remove some. The plugins are located in the Plugins directory in the main Notepad++ installation directory. They are DLL files and simply removing or adding them is enough.

When Notepad++ starts, it looks into its Plugins configuration folder and loads whatever dll it finds. Later, you can add plugins using the Settings -> Import -> Import plugins menu. Be careful to make sure your version of Notepad++ is up-to-date enough for new plugins and that the plugin is compatible with Notepad++ (some very old plugins will not work with newer versions of Notepad++, it is up to the developer of the plugin to add support or not).

Currently, Notepad++ can be found in an (older) ANSI version and the newer Unicode verison. The plugin has to match this version, otherwise it will not work (Notepad++ will warn you about this). Plugins can be found anywhere on the internet, but a large can be found in the Notepad++ Plugins project on SourceForge.net: http://sourceforge.net/projects/npp-plugins/. There is even a plugin, called Plugin Manager, which works out the installation details and version management for you.


Command Line

Notepad++.exe [-multiInst] [-noPlugin] [-ro] [-nosession] [-notabbar] [-n##] [-l$$$] [FILES]

Notepad++ supports a few command line parameters to control its startup. The following options are supported (they are case sensitive): p>

-c
Start editing in Column mode.
-multiInst
allow Notpead++ to start more than one instance. By default, if Notepad++ is already started files wil lbe opened in that instance, but this option will start a new one.
-noPlugin
Do not load any plugins. If you suspect a defunct plugin or you just do not wish to load them, add this option.
-ro
Any file now opened will be opened in Read only mode.
-nosession
Do not load the previous session if Notepad++ is started. Do not save the session on exit either.
-notabbar
Hide the Tab Bar, even if the settings say otherwise.
-nline number
Line number to go to for each file opened.
-xline number
Specify the horizontal position (in pixels) at which Notepad++ main window is to open.
-yline number
Specify the vertical position (in pixels) at which Notepad++ main window is to open.
-llanguage short name
Language to set for each file opened. $$$ is a short identifier string, of which the following are allowed:
normal, php, c, cpp, cs, objc, java, rc, html, xml, makefile, pascal, batch, ini, nfo, asp, sql, vb, javascript, css, perl, python, lua, tex, fortran, bash, actionscript, nsis, tcl, lisp, scheme, asm, diff, props, postscript, ruby, smalltalk, vhdl, kix, autoit, caml, ada, verilog, matlab, haskell, inno, cmake, yaml
Files
Anything else will be interpreted as a filename. Always quote your filename to allow the path to contain spaces, otherwise Notepad++ will split the single path into multiple paths at each space.

The order of the options is not important.

For compatibility, Notepad++ will first try to identify the entire command line as a filename, even if it is unquoted. It is however not recommended to do this, always quote the filename.


Control files

The startup behavior of Notepad++ can be adjusted with a few (0 sized) control files. Their absence or presence will control how Notepad++ acts: p>

doLocalConf.xml
If present, Notepad++ will use the installation directory for all configurations. If abscent, %APPDATA% is used instead.
asNotepad.xml
If present, Notepad++ will act as Windows Notepad, meaning it will launch in multiple instances, hides the tab bar and will not load the previous session.


Shell Extension

By default the Notepad++ installer comes with an Shell extension. This is not really part of the Notepad++ program but very useful. If you choose to install it, then any file you rightclick on will show an entry named “Edit with Notepad++” with the Notepad++ icon.

Please note that to install or remove the extension, it sometimes is required to restart the Explorer process. For this you can reboot, logout and log back in or use the taskmanager to kill explorer (Windows NT and up) and restart it again. Hitting Ctrl+Alt+Shift+Del works too.

If the Shell extension is already installed, the Notepad++ installer cannot update or overwrite it, you first have to uninstall it and restart Explorer.


Further help

If you want more information or help for Notepad++, or want to submit some feedback, these are some possibilities:

Main website and Forums

Bug Reports

Feature Requests

Patches


Main website and Forums

You can find further information and help for Notepad++ at:

The forums:
http://sourceforge.net/forum/?group_id=95717
The Wiki, known as NpWiki++:
http://sourceforge.net/apps/mediawiki/notepad-plus/index.php?title=Main_Page
IdeaTorrent:
http://sourceforge.net/apps/ideatorrent/notepad-plus/
and of course the main site:
http://notepad-plus.sourceforge.net/


Bug Reports

If you find that Notepad++ isn't working correctly or plain crashing, you probably encountered a bug. First check if you have the latest version, each release Notepad++ gets improved and bugs get fixed (unfortunately, sometimes added as well so always tread careful when updating). Also, if you just added or opgraded a plugin, it could be the cause of the bug.

Then, check if a plugin causes the trouble. Remove all plugins or start with the command line option to disable all plugins and see if the issue persists. If so:

Check the forums: maybe other users noticed it as well and found a fix or are in discussion.

Check the Bug tracker (http://sourceforge.net/tracker2/?group_id=95717&atid=612382): maybe the bug is already detected and added to the list. Search for it and if it's not there, you can add it and help the developers find and fix it (always be very clear what the problem is, what causes it and how to reproduce it. Crash reports are, unfortunately, currently not very helpful, a description on how to reproduce the crash is). Also please zip or 7-zip the NppDump.dmp file if any was produced, and attach it to the report: it contains the internal state of Notepad++ when the crash took place, an is invaluable to developpers.


Feature Requests

If you have a (very) good idea on how to improve Notepad++, you can request a feature using the Feature Request tracker (http://sourceforge.net/tracker2/?group_id=95717&atid=612385). If it hasn't been asked for before, you can do so here. There is no guarantee it will be added however; what is a great feature for one person might be a big nuisance for another, or it simply is too difficult or time consuming to add it in. Also, some feature requests would involve modifying the Scintilla component, which would prove unpractical. In such a case, the feature request would be better filed with the Scintilla project


Patches

If you are a developer/contributor and already have an improvement ready for Notepad++, you can submit a patch using the patch tracker (http://sourceforge.net/tracker2/?group_id=95717&atid=612384). This is the great part of Open Source, you can add some stuff in as well :)


Credits

This help file was written by Harry (harrybharry@users.sourceforge.net) and updated by CChris (cchris@users.sourceforge.net). It was converted to HTML using KompoZer, compiled to a help file with Microsoft HTML Help Workshop. Notepad++ is a product by Don Ho (don.h@free.fr), Microsoft and Microsoft Windows are registered trademarks.